#!/usr/bin/perl

use CGI::Fast qw(:standard);
use HTML::Mason::CGIHandler;
use URI;

{
  package HTML::Mason::Commands;

  ## anything you want available to components
  use Storable qw(freeze thaw);
  use URI::Escape;
  # use HTML::Prototype;
  use HTML::FillInForm;
  use Storable;
  use File::stat;

  my %g_Status;
}

# lazily-instantiated variables
my $cgi;
my $h;

while ($cgi = new CGI::Fast())
{
  my $uri = URI->new( $ENV{REQUEST_URI} );

  ## this is a hack, that emulates mod_perl
  $uri->path( $uri->path . 'index.html' )
          if $uri->path =~ /\/$/
  ;

  $ENV{PATH_INFO}    = $uri->path;
  $ENV{QUERY_STRING} = $uri->query;
  $ENV{REQUEST_URI}  = "$uri";

  ## this is lazily instantiated because %ENV is not set at startup time
  if (! $h) {
    $h = HTML::Mason::CGIHandler->new(
      comp_root       => $ENV{MASON_COMP_ROOT}
      , data_dir      => $ENV{MASON_DATA_ROOT}
      , error_mode    => 'fatal'
      , error_format  => 'line'
    );
  }

  ## hand off to mason
  eval { $h->handle_cgi_object($cgi) };

  ## catch error
  if ( my $raw_error = $@ ) {

    $raw_error =~ m/Error\sduring\scompilation\sof\s+(.+?):/g;

    my $File = $1 || "parser error!\n";

    print header;
    print start_html("Error on page");
    print h1("Error on $File");
    print "<pre>";
    foreach(split(/\t+/,$raw_error)) {
         chomp;
         print "$_<br />\n";
    }

    my $tmp = `cat $File`;
    $tmp =~ s/\>/&gt;/g;
    $tmp =~ s/\</&lt;/g;

    print "\n\n";

    my $lineC=1;
    foreach(split(/\n/, $tmp)) {
      chomp;
      print "$lineC: $_\n";
      $lineC++;
    }

    print "</pre>";

    print end_html;
    print STDERR "end";
    warn "$raw_error";

  }

  ## things went well
  else {

  }
}
exit 0;
